﻿using Syncfusion.SfSchedule.XForms;
using System;
using System.Collections.Generic;
using System.Text;
using Xamarin.Forms;

namespace DraggingTime_Schedule
{
    public class ScheduleBehavior: Behavior<ContentPage>
    {
        SfSchedule schedule;
        ContentPage contentPage;
        protected override void OnAttachedTo(ContentPage bindable)
        {
            base.OnAttachedTo(bindable);
            schedule = bindable.FindByName<SfSchedule>("schedule");
            contentPage = bindable;
            ScheduleAppointmentCollection scheduleAppointmentCollection = new ScheduleAppointmentCollection();
            //Adding schedule appointment in schedule appointment collection 
            scheduleAppointmentCollection.Add(new ScheduleAppointment()
            {
                StartTime = new DateTime(2019, 05, 31, 10, 0, 0),
                EndTime = new DateTime(2019, 05, 31, 12, 0, 0),
                Subject = "Meeting",
                Location = "Hutchison road",
            });
            schedule.AppointmentDragOver += Schedule_AppointmentDragOver;
            schedule.AppointmentDrop += SfSchedule_AppointmentDrop;
            schedule.CellDoubleTapped += Schedule_CellTapped;
            schedule.DataSource = scheduleAppointmentCollection;
        }
        private void Schedule_AppointmentDragOver(object sender, AppointmentDragEventArgs e)
        {
            schedule.DragDropSettings.ShowTimeIndicator = ((e.DraggingTime.Minute % 15) == 0);
        }

        private void Schedule_CellTapped(object sender, CellTappedEventArgs e)
        {
            contentPage.DisplayAlert("DateTime", (e.Appointment as ScheduleAppointment).StartTime.ToString("dd/mm/yyyy hh:mm:ss"), "close");
        }

        private void SfSchedule_AppointmentDrop(object sender, AppointmentDropEventArgs e)
        {
            var time = e.DropTime;
            var remainder = time.Minute % 15;
            var appointment = e.Appointment as ScheduleAppointment;
            var appointmentDuration = appointment.EndTime - appointment.StartTime;

            // Snap to previous/next tick
            if (remainder != 0)
            {
                // appointment UI updation
                e.DropTime = (remainder < 7) ? time.AddMinutes(-remainder) : time.AddMinutes(15 - remainder);

                // appointment start and end time data updation
                appointment.StartTime = e.DropTime;
                appointment.EndTime = e.DropTime.AddHours(appointmentDuration.Hours);
            }
        }
    }
}
